Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.ietf.jgss
Interface GSSContext

    public interface GSSContext

This interface encapsulates the GSS-API security context and provides the security services (wrap, unwrap, getMIC, verifyMIC) that are available over the context. Security contexts are established between peers using locally acquired credentials. Multiple contexts may exist simultaneously between a pair of peers, using the same or different set of credentials. GSS-API functions in a manner independent of the underlying transport protocol and depends on its calling application to transport its tokens between peers.

Before the context establishment phase is initiated, the context initiator may request specific characteristics desired of the established context. These can be set using the set methods. After the context is established, the caller can check the actual characteristic and services offered by the context using the query methods.

The context establishment phase begins with the first call to the init method by the context initiator. During this phase the initSecContext and acceptSecContext methods will produce GSS-API authentication tokens which the calling application needs to send to its peer. If an error occurs at any point, an exception will get thrown and the code will start executing in a catch block. If not, the normal flow of code continues and the application can make a call to the isEstablished() method. If this method returns false it indicates that a token is needed from its peer in order to continue the context establishment phase. A return value of true signals that the local end of the context is established. This may still require that a token be sent to the peer, if one is produced by GSS-API. During the context establishment phase, the isProtReady() method may be called to determine if the context can be used for the per-message operations. This allows applications to use per-message operations on contexts which aren't fully established.

After the context has been established or the isProtReady() method returns "true", the query routines can be invoked to determine the actual characteristics and services of the established context. The application can also start using the per-message methods, wrap and getMIC, to obtain cryptographic operations on application supplied data.

When the context is no longer needed, the application should call dispose to release any system resources the context may be using.

Based on the IETF RFC-2853.

Version:
  1.1 5/7/07
Author:
  Thomas Owusu

Field Summary
`static int` | `DEFAULT_LIFETIME` A lifetime constant representing the default context lifetime.
`static int` | `INDEFINITE_LIFETIME` A lifetime constant representing indefinite context lifetime.

Method Summary
`byte[]` | `acceptSecContext(byte[] inToken, int offset, int len)` Accepts a context token received from a context initiator.
`void` | `acceptSecContext(java.io.InputStream inStream, java.io.OutputStream outStream)` Accepts a context token received from a context initiator.
`void` | `dispose()` Releases any system resources and cryptographic information stored in the context object.
`byte[]` | `export()` Provided to support the sharing of work between multiple processes.
`boolean` | `getAnonymityState()` Returns "true" if this is an anonymous context.
`boolean` | `getConfState()` Returns the confidentiality service state over the context.
`boolean` | `getCredDelegState()` Returns the state of the delegated credentials for the context.
`GSSCredential` | `getDelegCred()` Returns the delegated credential object on the acceptor's side.
`boolean` | `getIntegState()` Returns the integrity service state over the context.
`int` | `getLifetime()` Returns the context lifetime in seconds.
`Oid` | `getMech()` Returns the mechanism oid for this context.
`byte[]` | `getMIC(byte[] inMsg, int offset, int len, MessageProp msgProp)` Computes a cryptographic MIC over the supplied message.
`void` | `getMIC(java.io.InputStream inStream, java.io.OutputStream outStream, MessageProp msgProp)` Computes a cryptographic MIC over the supplied message.
`boolean` | `getMutualAuthState()` Returns the state of the mutual authentication option for the context.
`boolean` | `getReplayDetState()` Returns the state of the replay detection option for the context.
`boolean` | `getSequenceDetState()` Returns the state of the sequence detection option for the context.
`GSSName` | `getSrcName()` Returns the name of the context initiator.
`GSSName` | `getTargName()` Returns the name of the context target (acceptor).
`int` | `getWrapSizeLimit(int qop, boolean confReq, int maxTokenSize)` Returns the maximum message size that, if presented to the wrap method with the same confReq and qop parameters, will result in an output token containing no more than the maxTokenSize bytes.
`byte[]` | `initSecContext(byte[] inputBuf, int offset, int len)` Initiates context establishment.
`int` | `initSecContext(java.io.InputStream inStream, java.io.OutputStream outStream)` Initiates context establishment.
`boolean` | `isEstablished()` Used during context establishment to determine the state of the context.
`boolean` | `isInitiator()` Returns "true" if this is the initiator of the context.
`boolean` | `isProtReady()` Returns "true" if the per message operations can be applied over the context.
`boolean` | `isTransferable()` Returns "true" if the context is transferable to other processes through the use of the export method.
`void` | `requestAnonymity(boolean state)` Requests anonymous support over the context.
`void` | `requestConf(boolean state)` Requests that confidentiality service be available over the context.
`void` | `requestCredDeleg(boolean state)` Sets the request state for the credential delegation flag for the context.
`void` | `requestInteg(boolean state)` Requests that integrity services be available over the context.
`void` | `requestLifetime(int lifetime)` Sets the desired lifetime for the context in seconds.
`void` | `requestMutualAuth(boolean state)` Sets the request state of the mutual authentication flag for the context.
`void` | `requestReplayDet(boolean state)` Sets the request state of the replay detection service for the context.
`void` | `requestSequenceDet(boolean state)` Sets the request state for the sequence checking service of the context.
`void` | `setChannelBinding(ChannelBinding cb)` Sets the channel bindings to be used during context establishment.
`byte[]` | `unwrap(byte[] inBuf, int offset, int len, MessageProp msgProp)` Used by the peer application to process tokens generated with the wrap call.
`void` | `unwrap(java.io.InputStream inStream, java.io.OutputStream outStream, MessageProp msgProp)` Used by the peer application to process tokens generated with the wrap call.
`void` | `verifyMIC(byte[] inTok, int tokOffset, int TokLen, byte[] inMsg, int msgOffset, int msgLen, MessageProp msgProp)` Verifies the cryptographic MIC contained in the supplied token.
`void` | `verifyMIC(java.io.InputStream tokStream, java.io.InputStream msgStream, MessageProp msgProp)` Verifies the cryptographic MIC contained in the supplied token.
`byte[]` | `wrap(byte[] inBuf, int offset, int len, MessageProp msgProp)` Applies per-message security services over the established security context.
`void` | `wrap(java.io.InputStream inStream, java.io.OutputStream outStream, MessageProp msgProp)` Allows to apply per-message security services over the established security context.

Field Detail

### DEFAULT_LIFETIME

    static final int DEFAULT_LIFETIME

  A lifetime constant representing the default context lifetime.

  See Also:
    Constant Field Values

### INDEFINITE_LIFETIME

    static final int INDEFINITE_LIFETIME

  A lifetime constant representing indefinite context lifetime.

  See Also:
    Constant Field Values

Method Detail

### initSecContext

    byte[] initSecContext(byte[] inputBuf,
                          int offset,
                          int len)
                          throws GSSException

  Initiates context establishment. Called by the context initiator to start the context creation process. This is equivalent to the stream based method except that the token buffers are handled as byte arrays instead of using stream objects. This method may return an output token which the application will need to send to the peer for processing by the accept call. "null" return value indicates that no token needs to be sent to the peer. The application can call isEstablished() to determine if the context establishment phase is complete for this peer. A return value of "false" from isEstablished() indicates that more tokens are expected to be supplied to the initSecContext() method. Note that it is possible that the initSecContext() method return a token for the peer, and isEstablished() return "true" also. This indicates that the token needs to be sent to the peer, but the local end of the context is now fully established.

  Upon completion of the context establishment, the available context options may be queried through the get methods.

  Parameters:
    `inputBuf` - Token generated by the peer. This parameter is ignored on the first call.
    `offset` - The offset within the inputBuf where the token begins.
    `len` - The length of the token within the inputBuf (starting at the offset).
  Returns:
    The token to be transmitted to the peer. Null is returned if no token needs to be sent.
  Throws:
    `GSSException`

### initSecContext

    int initSecContext(java.io.InputStream inStream,
                       java.io.OutputStream outStream)
                       throws GSSException

  Initiates context establishment. Called by the context initiator to start the context creation process. This is equivalent to the byte array based method. This method may write an output token to the outStream, which the application will need to send to the peer for processing by the accept call. 0 bytes written to the output stream indicate that no token needs to be sent to the peer. The application can call isEstablished() to determine if the context establishment phase is complete for this peer. A return value of "false" from isEstablished indicates that more tokens are expected to be supplied to the initSecContext method. Note that it is possible that the initSecContext() method return a token for the peer, and isEstablished() return "true" also. This indicates that the token needs to be sent to the peer, but the local end of the context is now fully established.

  The GSS-API authentication tokens contain a definitive start and end. This method will attempt to read one of these tokens per invocation, and may block on the stream if only part of the token is available.

  Upon completion of the context establishment, the available context options may be queried through the get methods.

  Parameters:
    `inStream` - Contains the token generated by the peer. This parameter is ignored on the first call.
    `outStream` - Output stream where the output token will be written. During the final stage of context establishment, there may be no bytes written.
  Returns:
    The number of bytes written to the output stream.
  Throws:
    `GSSException`

### acceptSecContext

    byte[] acceptSecContext(byte[] inToken,
                            int offset,
                            int len)
                            throws GSSException

  Accepts a context token received from a context initiator. Called by the context acceptor upon receiving a token from the peer. This call is equivalent to the stream based method except that the token buffers are handled as byte arrays instead of using stream objects.

  This method may return an output token which the application will need to send to the peer for further processing by the init call. "null" return value indicates that no token needs to be sent to the peer. The application can call isEstablished() to determine if the context establishment phase is complete for this peer. A return value of "false" from isEstablished() indicates that more tokens are expected to be supplied to this method.

  Note that it is possible that acceptSecContext() return a token for the peer, and isEstablished() return "true" also. This indicates that the token needs to be sent to the peer, but the local end of the context is now fully established.

  Upon completion of the context establishment, the available context options may be queried through the get methods.

  Parameters:
    `inTok` - Token generated by the peer.
    `offset` - The offset within the inTok where the token begins.
    `len` - The length of the token within the inTok (starting at the offset).
  Returns:
    Token to be sent to the peer. Null if no token is to be sent to the peer.
  Throws:
    `GSSException`

### acceptSecContext

    void acceptSecContext(java.io.InputStream inStream,
                          java.io.OutputStream outStream)
                          throws GSSException

  Accepts a context token received from a context initiator. Called by the context acceptor upon receiving a token from the peer. This call is equivalent to the byte array method. It may write an output token to the outStream, which the application will need to send to the peer for processing by its initSecContext method. 0 bytes written to the output stream indicate that no token needs to be sent to the peer. The application can call isEstablished() to determine if the context establishment phase is complete for this peer. A return value of "false" from isEstablished() indicates that more tokens are expected to be supplied to this method.

  Note that it is possible that acceptSecContext() return a token for the peer, and isEstablished() return "true" also. This indicates that the token needs to be sent to the peer, but the local end of the context is now fully established.

  The GSS-API authentication tokens contain a definitive start and end. This method will attempt to read one of these tokens per invocation, and may block on the stream if only part of the token is available.

  Upon completion of the context establishment, the available context options may be queried through the get methods.

  Parameters:
    `inStream` - Contains the token generated by the peer.
    `outStream` - Output stream where the output token will be written. During the final stage of context establishment, there may be no bytes written.
  Throws:
    `GSSException`

### isEstablished

    boolean isEstablished()

  Used during context establishment to determine the state of the context. Returns "true" if this is a fully established context on the caller's side and no more tokens are needed from the peer. Should be called after a call to initSecContext() or acceptSecContext() when no GSSException is thrown.

  Returns:
    "true" if this is a fully established context.

### dispose

    void dispose()
                 throws GSSException

  Releases any system resources and cryptographic information stored in the context object. This will invalidate the context.

  Throws:
    `GSSException`

### getWrapSizeLimit

    int getWrapSizeLimit(int qop,
                         boolean confReq,
                         int maxTokenSize)
                         throws GSSException

  Returns the maximum message size that, if presented to the wrap method with the same confReq and qop parameters, will result in an output token containing no more than the maxTokenSize bytes.

  This call is intended for use by applications that communicate over protocols that impose a maximum message size. It enables the application to fragment messages prior to applying protection.

  GSS-API implementations are recommended but not required to detect invalid QOP values when getWrapSizeLimit is called. This routine guarantees only a maximum message size, not the availability of specific QOP values for message protection.

  Successful completion of this call does not guarantee that wrap will be able to protect a message of the computed length, since this ability may depend on the availability of system resources at the time that wrap is called. However, if the implementation itself imposes an upper limit on the length of messages that may be processed by wrap, the implementation should not return a value that is greater than this length.

  Parameters:
    `qop` - Indicates the level of protection wrap will be asked to provide.
    `confReq` - Indicates if wrap will be asked to provide privacy service.
    `maxTokenSize` - The desired maximum size of the token emitted by wrap.
  Returns:
    The size of buffer.
  Throws:
    `GSSException`

### wrap

    byte[] wrap(byte[] inBuf,
                int offset,
                int len,
                MessageProp msgProp)
                throws GSSException

  Applies per-message security services over the established security context. The method will return a token with a cryptographic MIC and may optionally encrypt the specified inBuf. This method is equivalent in functionality to its stream counterpart. The returned byte array will contain both the MIC and the message.

  The MessageProp object is instantiated by the application and used to specify a QOP value which selects cryptographic algorithms, and a privacy service to optionally encrypt the message. The underlying mechanism that is used in the call may not be able to provide the privacy service. It sets the actual privacy service that it does provide in this MessageProp object which the caller should then query upon return. If the mechanism is not able to provide the requested QOP, it throws a GSSException with the BAD_QOP code.

  Since some application-level protocols may wish to use tokens emitted by wrap to provide "secure framing", implementations should support the wrapping of zero-length messages.

  The application will be responsible for sending the token to the peer.

  Parameters:
    `inBuf` - Application data to be protected.
    `offset` - The offset within the inBuf where the data begins.
    `len` - The length of the data within the inBuf (starting at the offset).
    `msgProp` - Instance of MessageProp that is used by the application to set the desired QOP and privacy state. Set the desired QOP to 0 to request the default QOP. Upon return from this method, this object will contain the the actual privacy state that was applied to the message by the underlying mechanism.
  Returns:
    The wrapped token.
  Throws:
    `GSSException`

### wrap

    void wrap(java.io.InputStream inStream,
              java.io.OutputStream outStream,
              MessageProp msgProp)
              throws GSSException

  Allows to apply per-message security services over the established security context. The method will produce a token with a cryptographic MIC and may optionally encrypt the message in inStream. The outStream will contain both the MIC and the message.

  The MessageProp object is instantiated by the application and used to specify a QOP value which selects cryptographic algorithms, and a privacy service to optionally encrypt the message. The underlying mechanism that is used in the call may not be able to provide the privacy service. It sets the actual privacy service that it does provide in this MessageProp object which the caller should then query upon return. If the mechanism is not able to provide the requested QOP, it throws a GSSException with the BAD_QOP code.

  Since some application-level protocols may wish to use tokens emitted by wrap to provide "secure framing", implementations should support the wrapping of zero-length messages.

  The application will be responsible for sending the token to the peer.

  Parameters:
    `inStream` - Input stream containing the application data to be protected.
    `outStream` - The output stream to write the protected message to. The application is responsible for sending this to the other peer for processing in its unwrap method.
    `msgProp` - Instance of MessageProp that is used by the application to set the desired QOP and privacy state. Set the desired QOP to 0 to request the default QOP. Upon return from this method, this object will contain the the actual privacy state that was applied to the message by the underlying mechanism.
  Throws:
    `GSSException`

### unwrap

    byte[] unwrap(byte[] inBuf,
                  int offset,
                  int len,
                  MessageProp msgProp)
                  throws GSSException

  Used by the peer application to process tokens generated with the wrap call. This call is equal in functionality to its stream counterpart. The method will return the message supplied in the peer application to the wrap call, verifying the embedded MIC.

  The MessageProp object is instantiated by the application and is used by the underlying mechanism to return information to the caller such as the QOP, whether confidentiality was applied to the message, and other supplementary message state information.

  Since some application-level protocols may wish to use tokens emitted by wrap to provide "secure framing", implementations should support the wrapping and unwrapping of zero-length messages.

  Parameters:
    `inBuf` - GSS-API wrap token received from peer.
    `offset` - The offset within the inBuf where the token begins.
    `len` - The length of the token within the inBuf (starting at the offset).
    `msgProp` - Upon return from the method, this object will contain the applied QOP, the privacy state of the message, and supplementary information described in 4.12.3 stating whether the token was a duplicate, old, out of sequence or arriving after a gap.
  Returns:
    The unwrapped token.
  Throws:
    `GSSException`

### unwrap

    void unwrap(java.io.InputStream inStream,
                java.io.OutputStream outStream,
                MessageProp msgProp)
                throws GSSException

  Used by the peer application to process tokens generated with the wrap call. This call is equal in functionality to its byte array counterpart. It will produce the message supplied in the peer application to the wrap call, verifying the embedded MIC.

  The MessageProp object is instantiated by the application and is used by the underlying mechanism to return information to the caller such as the QOP, whether confidentiality was applied to the message, and other supplementary message state information.

  Since some application-level protocols may wish to use tokens emitted by wrap to provide "secure framing", implementations should support the wrapping and unwrapping of zero-length messages.

  Parameters:
    `inStream` - Input stream containing the GSS-API wrap token received from the peer.
    `outStream` - The output stream to write the application message to.
    `msgProp` - Upon return from the method, this object will contain the applied QOP, the privacy state of the message, and supplementary information described in 4.12.3 stating whether the token was a duplicate, old, out of sequence or arriving after a gap.
  Throws:
    `GSSException`

### getMIC

    byte[] getMIC(byte[] inMsg,
                  int offset,
                  int len,
                  MessageProp msgProp)
                  throws GSSException

  Computes a cryptographic MIC over the supplied message. Returns a token containing a cryptographic MIC for the supplied message, for transfer to the peer application. Unlike wrap, which encapsulates the user message in the returned token, only the message MIC is returned in the output token. This method is identical in functionality to its stream counterpart.

  Note that privacy can only be applied through the wrap call.

  Since some application-level protocols may wish to use tokens emitted by getMIC to provide "secure framing", implementations should support derivation of MICs from zero-length messages.

  Parameters:
    `inMsg` - Message to generate MIC over.
    `offset` - The offset within the inMsg where the token begins.
    `len` - The length of the token within the inMsg (starting at the offset).
    `msgProp` - Instance of MessageProp that is used by the application to set the desired QOP. Set the desired QOP to 0 in msgProp to request the default QOP. Alternatively pass in "null" for msgProp to request default QOP.
  Returns:
    The cryptogaphic MIC.
  Throws:
    `GSSException`

### getMIC

    void getMIC(java.io.InputStream inStream,
                java.io.OutputStream outStream,
                MessageProp msgProp)
                throws GSSException

  Computes a cryptographic MIC over the supplied message. Produces a token containing a cryptographic MIC for the supplied message, for transfer to the peer application. Unlike wrap, which encapsulates the user message in the returned token, only the message MIC is produced in the output token. This method is identical in functionality to its byte array counterpart.

  Note that privacy can only be applied through the wrap call.

  Since some application-level protocols may wish to use tokens emitted by getMIC to provide "secure framing", implementations should support derivation of MICs from zero-length messages.

  Parameters:
    `inStream` - Input stream containing the message to generate MIC over.
    `outStream` - Output stream to write the GSS-API output token to.
    `msgProp` - Instance of MessageProp that is used by the application to set the desired QOP. Set the desired QOP to 0 in msgProp to request the default QOP. Alternatively pass in "null" for msgProp to request default QOP.
  Throws:
    `GSSException`

### verifyMIC

    void verifyMIC(byte[] inTok,
                   int tokOffset,
                   int TokLen,
                   byte[] inMsg,
                   int msgOffset,
                   int msgLen,
                   MessageProp msgProp)
                   throws GSSException

  Verifies the cryptographic MIC contained in the supplied token. The MIC is verified over the supplied message. This method is equivalent in functionality to its stream counterpart.

  The MessageProp object is instantiated by the application and is used by the underlying mechanism to return information to the caller such as the QOP indicating the strength of protection that was applied to the message and other supplementary message state information.

  Since some application-level protocols may wish to use tokens emitted by getMIC to provide "secure framing", implementations should support the calculation and verification of MICs over zero-length messages.

  Parameters:
    `inTok` - Token generated by peer's getMIC method.
    `tokOffset` - The offset within the inTok where the token begins.
    `tokLen` - The length of the token within the inTok (starting at the offset).
    `inMsg` - Application message to verify the cryptographic MIC over.
    `msgOffset` - The offset within the inMsg where the message begins.
    `msgLen` - The length of the message within the inMsg (starting at the offset).
    `msgProp` - Upon return from the method, this object will contain the applied QOP and supplementary information described in 4.12.3 stating whether the token was a duplicate, old, out of sequence or arriving after a gap. The confidentiality state will be set to "false".
  Throws:
    `GSSException`

### verifyMIC

    void verifyMIC(java.io.InputStream tokStream,
                   java.io.InputStream msgStream,
                   MessageProp msgProp)
                   throws GSSException

  Verifies the cryptographic MIC contained in the supplied token. The MIC is verified over the supplied message. This method is equivalent in functionality to its byte array counterpart.

  The MessageProp object is instantiated by the application and is used by the underlying mechanism to return information to the caller such as the QOP indicating the strength of protection that was applied to the message and other supplementary message state information.

  Since some application-level protocols may wish to use tokens emitted by getMIC to provide "secure framing", implementations should support the calculation and verification of MICs over zero-length messages.

  Parameters:
    `tokStream` - Input stream containing the token generated by peer's getMIC method.
    `msgStream` - Input stream containing the application message to verify the cryptographic MIC over.
    `msgProp` - Upon return from the method, this object will contain the applied QOP and supplementary information described in 4.12.3 stating whether the token was a duplicate, old, out of sequence or arriving after a gap. The confidentiality state will be set to "false".
  Throws:
    `GSSException`

### export

    byte[] export()
                  throws GSSException

  Provided to support the sharing of work between multiple processes. This routine will typically be used by the context-acceptor, in an application where a single process receives incoming connection requests and accepts security contexts over them, then passes the established context to one or more other processes for message exchange. This method deactivates the security context and creates an interprocess token which, when passed to the byte array constructor of the GSSContext interface in another process, will re-activate the context in the second process. Only a single instantiation of a given context may be active at any one time; a subsequent attempt by a context exporter to access the exported security context will fail. The implementation may constrain the set of processes by which the interprocess token may be imported, either as a function of local security policy, or as a result of implementation decisions. For example, some implementations may constrain contexts to be passed only between processes that run under the same account, or which are part of the same process group. The interprocess token may contain security-sensitive information (for example cryptographic keys). While mechanisms are encouraged to either avoid placing such sensitive information within interprocess tokens, or to encrypt the token before returning it to the application, in a typical GSS-API implementation this may not be possible. Thus the application must take care to protect the interprocess token, and ensure that any process to which the token is transferred is trustworthy.

  Throws:
    `GSSException`

### requestMutualAuth

    void requestMutualAuth(boolean state)
                           throws GSSException

  Sets the request state of the mutual authentication flag for the context. This method is only valid before the context creation process begins and only for the initiator.

  Parameters:
    `state` - Boolean representing if mutual authentication should be requested during context establishment.
  Throws:
    `GSSException`

### requestReplayDet

    void requestReplayDet(boolean state)
                          throws GSSException

  Sets the request state of the replay detection service for the context. This method is only valid before the context creation process begins and only for the initiator.

  Parameters:
    `state` - Boolean representing if replay detection is desired over the established context.
  Throws:
    `GSSException`

### requestSequenceDet

    void requestSequenceDet(boolean state)
                            throws GSSException

  Sets the request state for the sequence checking service of the context. This method is only valid before the context creation process begins and only for the initiator.

  Parameters:
    `state` - Boolean representing if sequence detection is desired over the established context.
  Throws:
    `GSSException`

### requestCredDeleg

    void requestCredDeleg(boolean state)
                          throws GSSException

  Sets the request state for the credential delegation flag for the context. This method is only valid before the context creation process begins and only for the initiator.

  Parameters:
    `state` - Boolean representing if credential delegation is desired.
  Throws:
    `GSSException`

### requestAnonymity

    void requestAnonymity(boolean state)
                          throws GSSException

  Requests anonymous support over the context. This method is only valid before the context creation process begins and only for the initiator.

  Parameters:
    `state` - Boolean representing if anonymity support is requested.
  Throws:
    `GSSException`

### requestConf

    void requestConf(boolean state)
                     throws GSSException

  Requests that confidentiality service be available over the context. This method is only valid before the context creation process begins and only for the initiator.

  Parameters:
    `state` - Boolean indicating if confidentiality services are to be requested for the context.
  Throws:
    `GSSException`

### requestInteg

    void requestInteg(boolean state)
                      throws GSSException

  Requests that integrity services be available over the context. This method is only valid before the context creation process begins and only for the initiator.

  Parameters:
    `state` - Boolean indicating if integrity services are to be requested for the context.
  Throws:
    `GSSException`

### requestLifetime

    void requestLifetime(int lifetime)
                         throws GSSException

  Sets the desired lifetime for the context in seconds. This method is only valid before the context creation process begins and only for the initiator. Use GSSContext.INDEFINITE_LIFETIME and GSSContext.DEFAULT_LIFETIME to request indefinite and default context lifetime, respectively.

  Parameters:
    `lifetime` - The desired context lifetime in seconds.
  Throws:
    `GSSException`

### setChannelBinding

    void setChannelBinding(ChannelBinding cb)
                           throws GSSException

  Sets the channel bindings to be used during context establishment. This method is only valid before the context creation process begins.

  Parameters:
    `cb` - Channel bindings to be used.
  Throws:
    `GSSException`

### getCredDelegState

    boolean getCredDelegState()

  Returns the state of the delegated credentials for the context. When issued before context establishment is completed or when the isProtReady method returns "false", it returns the desired state, otherwise it will indicate the actual state over the established context.

  Returns:
    Whether or not credentials are being delegated.

### getMutualAuthState

    boolean getMutualAuthState()

  Returns the state of the mutual authentication option for the context. When issued before context establishment completes or when the isProtReady method returns "false", it returns the desired state, otherwise it will indicate the actual state over the established context.

  Returns:
    Whether or not the peer is required to authenticate itself to the initiator.

### getReplayDetState

    boolean getReplayDetState()

  Returns the state of the replay detection option for the context. When issued before context establishment completes or when the isProtReady method returns "false", it returns the desired state, otherwise it will indicate the actual state over the established context.

  Returns:
    Whether or not replay detection is in effect.

### getSequenceDetState

    boolean getSequenceDetState()

  Returns the state of the sequence detection option for the context. When issued before context establishment completes or when the isProtReady method returns "false", it returns the desired state, otherwise it will indicate the actual state over the established context.

  Returns:
    Whether or not sequence detection is in effect.

### getAnonymityState

    boolean getAnonymityState()

  Returns "true" if this is an anonymous context. When issued before context establishment completes or when the isProtReady method returns "false", it returns the desired state, otherwise it will indicate the actual state over the established context.

  Returns:
    Whether or not this is an anonymous context.

### isTransferable

    boolean isTransferable()
                           throws GSSException

  Returns "true" if the context is transferable to other processes through the use of the export method. This call is only valid on fully established contexts.

  Returns:
    Whether or not this context may be transfered using the method.
  Throws:
    `GSSException`
  See Also:
    `export()`

### isProtReady

    boolean isProtReady()

  Returns "true" if the per message operations can be applied over the context. Some mechanisms may allow the usage of per-message operations before the context is fully established. This will also indicate that the get methods will return actual context state characteristics instead of the desired ones.

  Returns:
    Whether or not the context is ready for per-message to be used.

### getConfState

    boolean getConfState()

  Returns the confidentiality service state over the context. When issued before context establishment completes or when the isProtReady method returns "false", it returns the desired state, otherwise it will indicate the actual state over the established context.

  Returns:
    Whether or not confidentiality services are available on this context.

### getIntegState

    boolean getIntegState()

  Returns the integrity service state over the context. When issued before context establishment completes or when the isProtReady method returns "false", it returns the desired state, otherwise it will indicate the actual state over the established context.

  Returns:
    Whether or not integrity services are available on on this context.

### getLifetime

    int getLifetime()

  Returns the context lifetime in seconds. When issued before context establishment completes or when the isProtReady method returns "false", it returns the desired lifetime, otherwise it will indicate the remaining lifetime for the context.

  Returns:
    The lifetime remaining for this context.

### getSrcName

    GSSName getSrcName()
                       throws GSSException

  Returns the name of the context initiator. This call is valid only after the context is fully established or the isProtReady method returns "true". It is guaranteed to return an MN.

  Returns:
    The name of the context initiator.
  Throws:
    `GSSException`

### getTargName

    GSSName getTargName()
                        throws GSSException

  Returns the name of the context target (acceptor). This call is valid only after the context is fully established or the isProtReady method returns "true". It is guaranteed to return an MN.

  Returns:
    The name of the context acceptor.
  Throws:
    `GSSException`

### getMech

    Oid getMech()
                throws GSSException

  Returns the mechanism oid for this context.

  Returns:
    The Oid representing the mechamism for this context.
  Throws:
    `GSSException`

### getDelegCred

    GSSCredential getDelegCred()
                               throws GSSException

  Returns the delegated credential object on the acceptor's side. This call is only valid on fully established contexts. Call the `getCredDelegState` method to check for availability of delegated credentials.

  Returns:
    The credentials delegated to the acceptor.
  Throws:
    `GSSException`

### isInitiator

    boolean isInitiator()
                        throws GSSException

  Returns "true" if this is the initiator of the context. This call is only valid after the context creation process has started.

  Returns:
    Whether or not the context established between this context and the peer was initiated from this context.
  Throws:
    `GSSException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD